package com.ruoyi.project.sems.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.framework.config.RuoYiConfig;
import com.ruoyi.project.common.domain.TCommonfile;
import com.ruoyi.project.common.mapper.TCommonfileMapper;
import com.ruoyi.project.sems.domain.TSpecdevYlgd;
import com.ruoyi.project.sems.his.domain.TSpechiYlgd;
import com.ruoyi.project.sems.mapper.TSpecdevYlgdMapper;
import com.ruoyi.project.sems.service.ITSpecdevYlgdService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.IOException;
import java.time.LocalDate;
import java.util.List;

/**
 * 特种设备压力管道台账Service业务层处理
 *
 * @author ruoyi
 * @date 2021-07-22
 */
@Service("tSpecdevYlgdService")
public class TSpecdevYlgdServiceImpl extends ServiceImpl<TSpecdevYlgdMapper, TSpecdevYlgd> implements ITSpecdevYlgdService
{
    @Resource
    private TSpecdevYlgdMapper tSpecdevYlgdMapper;
    @Resource
    private TCommonfileMapper tCommonfileMapper;
    /**
     * 查询特种设备压力管道台账
     *
     * @param id 特种设备压力管道台账ID
     * @return 特种设备压力管道台账
     */
    @Override
    public TSpecdevYlgd selectTSpecdevYlgdById(Long id)
    {
        return tSpecdevYlgdMapper.selectTSpecdevYlgdById(id);
    }

    /**
     * 查询特种设备压力管道台账列表
     *
     * @param tSpecdevYlgd 特种设备压力管道台账
     * @return 特种设备压力管道台账
     */
    @Override
    public List<TSpecdevYlgd> selectTSpecdevYlgdList(TSpecdevYlgd tSpecdevYlgd)
    {
        return tSpecdevYlgdMapper.selectTSpecdevYlgdList(tSpecdevYlgd);
    }

    @Override
    public List<TSpecdevYlgd> selectYlgdLengthList(TSpecdevYlgd tSpecdevYlgd)
    {
        return tSpecdevYlgdMapper.selectYlgdLengthList(tSpecdevYlgd);
    }

    @Override
    public List<TSpecdevYlgd> selectTSpecdevYlgdListByYear(TSpecdevYlgd tSpecdevYlgd) {
         return tSpecdevYlgdMapper.selectTSpecdevYlgdListByYear(tSpecdevYlgd);
    }

    /**
     * 新增特种设备压力管道台账
     *
     * @param tSpecdevYlgd 特种设备压力管道台账
     * @return 结果
     */
    @Override
    public int insertTSpecdevYlgd(TSpecdevYlgd tSpecdevYlgd)
    {
        return tSpecdevYlgdMapper.insertTSpecdevYlgd(tSpecdevYlgd);
    }

    /**
     * 修改特种设备压力管道台账
     *
     * @param tSpecdevYlgd 特种设备压力管道台账
     * @return 结果
     */
    @Override
    public int updateTSpecdevYlgd(TSpecdevYlgd tSpecdevYlgd)
    {
        return tSpecdevYlgdMapper.updateTSpecdevYlgd(tSpecdevYlgd);
    }

    /**
     * 批量删除特种设备压力管道台账
     *
     * @param ids 需要删除的特种设备压力管道台账ID
     * @return 结果
     */
    @Override
    public int deleteTSpecdevYlgdByIds(Long[] ids)
    {
        return tSpecdevYlgdMapper.deleteTSpecdevYlgdByIds(ids);
    }

    /**
     * 删除特种设备压力管道台账信息
     *
     * @param id 特种设备压力管道台账ID
     * @return 结果
     */
    @Override
    public int deleteTSpecdevYlgdById(Long id)
    {
        return tSpecdevYlgdMapper.deleteTSpecdevYlgdById(id);
    }

    @Override
    public int updateTSpecdevYlgdByHi(TSpechiYlgd hientity) {
        return tSpecdevYlgdMapper.updateTSpecdevYlgdByHi(hientity);
    }

    @Override
    public void duplicateTSpecdevYlgd() {
        tSpecdevYlgdMapper.duplicateTSpecdevYlgd();
    }

    @Override
    @Transactional
    public int importFiles(List<MultipartFile> files, String plantCode, String fileType , String userId) throws Exception {
        for (MultipartFile file : files) {
            if (!file.isEmpty()) {
                String input = file.getOriginalFilename();
                int index = input.indexOf('_');
                String weiHao = (index != -1) ? input.substring(0, index) : input;
                System.out.println(weiHao); // 输出: 位号
                TSpecdevYlgd param = new TSpecdevYlgd();
                param.setDevno(weiHao);
                param.setPlantCode(plantCode);
                List<TSpecdevYlgd> list = tSpecdevYlgdMapper.selectTSpecdevYlgdListByDevNo(param);
                if (list.size() > 0) {
                    for (TSpecdevYlgd t: list
                    ) {
                        Long id = t.getId();
                        // 获取当前日期
                        LocalDate currentDate = LocalDate.now();
                        // 获取年份
                        int year = currentDate.getYear();
                        String dir = "/sems-ylgd-" + fileType + "/" + year;
                        String url = null;
                        try {
                            url = FileUploadUtils.upload(RuoYiConfig.getFilePath(dir), file);
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        long size = file.getSize()/1024;
                        TCommonfile tCommonfile = new TCommonfile();
                        tCommonfile.setFileUrl(url);
                        tCommonfile.setFileName(file.getOriginalFilename());
                        tCommonfile.setCreaterCode(userId);
                        tCommonfile.setpId(id);
                        tCommonfile.setpType("sems-ylgd-"+fileType);
                        tCommonfile.setFileSize(String.valueOf(size));
                        tCommonfileMapper.insertTCommonfile(tCommonfile);
                    }
                }else {
                    throw new Exception( StringUtils.format(input +":无法找到对应设备"));
                }
            }
        }
        return 1;
    }
}
